;;;; Copyright (c) 2004 David Lichteblau <david@lichteblau.com>
;;;;
;;;; This program is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2 of the License, or
;;;; (at your option) any later version.
;;;;
;;;; This program is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;;
;;;; You should have received a copy of the GNU General Public License
;;;; along with this program; if not, write to the Free Software
;;;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(in-package :cl-user)

(defpackage :jdi
  (:use)
  (:export #:jdwp-connect
	   #:with-virtual-machine

	   #:JDWP-ERROR
	   #:jdwp-handler-case
	   #:jdwp-error-code

	   #:VIRTUAL-MACHINE
	   #:all-classes
	   #:all-threads
	   #:base-directory
	   #:bootstrap-class-path
	   #:class-path
	   #:classes-by-name
	   #:classes-by-signature
	   #:description
	   #:dispose
	   #:exit
	   #:get-capability
	   #:id-sizes
	   #:jdwp-version
	   #:request-event
	   #:cancel-request
	   #:resume
	   #:suspend
	   #:top-level-thread-groups
	   #:version
	   #:read-event-set
	   
	   #:TYPE
	   #:name
	   #:signature
	   
	   #:PRIMITIVE-TYPE

	   #:REFERENCE-TYPE
	   #:signature
	   #:all-fields
	   #:all-methods
	   #:fields
	   #:field-value
	   #:field-values
	   #:interfaces
	   #:methods
	   #:source-file

	   #:ARRAY-TYPE
	   #:component-signature
	   #:component-type
	   #:component-type-name

	   #:CLASS-TYPE
	   #:superclass
	   #:subclasses
	   
	   #:INTERFACE-TYPE
	   #:subinterfaces
	   #:superinterfaces

	   #:MEMBER
	   #:declaring-type
	   #:modifiers
	   #:package-private-p
	   #:privatep
	   #:protectedp
	   #:publicp
	   #:finalp
	   #:staticp
	   #:syntheticp

	   #:FIELD
	   #:transientp
	   #:volatilep

	   #:METHOD
	   #:argument-type-names
	   #:argument-types
	   #:return-type-name
	   #:abstractp
	   #:nativep
	   #:synchronizedp
	   #:local-variables
	   #:guess-local-variables
	   #:lines

	   #:OBJECT
	   #:THREAD-GROUP
	   #:THREAD

	   #:THREAD
	   #:group
	   #:status
	   #:suspendedp
	   #:frames
	   
	   #:THREAD-GROUP
	   #:parent
	   #:child-threads
	   #:child-groups

	   #:FRAME
	   #:method
	   #:get-values
	   #:this-object

	   #:ARRAY
	   #:length
	   #:data
	   #:elt

	   #:LOCATION
	   #:line-number
	   #:code-index

	   #:LOCAL-VARIABLE
	   #:argumentp
	   #:index
	   #:visible-in-p
	   #:type-name

	   #:EVENT-REQUEST
	   #:suspend-policy
	   #:plist
	   #:FIELD-ACCESS-REQUEST
	   #:BREAKPOINT-REQUEST
	   #:CLASS-PREPARE-REQUEST
	   #:CLASS-UNLOAD-REQUEST
	   #:EXCEPTION-REQUEST
	   #:caughtp
	   #:uncaughtp
	   #:METHOD-ENTRY-REQUEST
	   #:METHOD-EXIT-REQUEST
	   #:FIELD-MODIFICATION-REQUEST
	   #:STEP-REQUEST
	   #:size
	   #:depth
	   #:THREAD-DEATH-REQUEST
	   #:THREAD-START-REQUEST
	   #:VM-DEATH-REQUEST
	   #:VM-DISCONNECTED-REQUEST
	   #:VM-START-REQUEST
	   #:WATCHPOINT-REQUEST

	   #:EVENT
	   #:THREAD-EVENT
	   #:LOCATABLE-EVENT
	   #:WATCHPOINT-EVENT

	   #:EVENT-SET
	   #:events

	   #:FIELD-ACCESS-EVENT
	   #:BREAKPOINT-EVENT
	   #:CLASS-PREPARE-EVENT
	   #:class
	   #:CLASS-UNLOAD-EVENT
	   #:EXCEPTION-EVENT
	   #:exception
	   #:catch-location
	   #:METHOD-ENTRY-EVENT
	   #:METHOD-EXIT-EVENT
	   #:FIELD-MODIFICATION-EVENT
	   #:value
	   #:STEP-EVENT
	   #:THREAD-DEATH-EVENT
	   #:THREAD-START-EVENT
	   #:VM-DEATH-EVENT
	   #:VM-DISCONNECTED-EVENT
	   #:VM-START-EVENT

	   #:request
	   ))

(defpackage :jdii
  (:use :cl :dlisp)
  (:export #:+typetag-class+
	   #:+typetag-interface+
	   #:+typetag-array+

	   #:+classstatus-verified+
	   #:+classstatus-prepared+
	   #:+classstatus-initialized+
	   #:+classstatus-error+))
