;;;; Copyright (c) 2003,2004 David Lichteblau <david@lichteblau.com>
;;;;
;;;; This program is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2 of the License, or
;;;; (at your option) any later version.
;;;;
;;;; This program is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;;
;;;; You should have received a copy of the GNU General Public License
;;;; along with this program; if not, write to the Free Software
;;;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(in-package :dlisp)

(defun %read-sequence-partial-fill (seq stream start end)
  (setf (elt seq start) (read-byte stream))
  (incf start)
  (handler-case
      (while (and (< start end) (listen stream))
	(setf (elt seq start) (read-byte stream))
	(incf start))
    (end-of-file ()))
  start)

(defun array-to-ipaddr (array)
  (logior (ash (canonicalize-n-unsigned (elt array 0) 8) 24)
	  (ash (canonicalize-n-unsigned (elt array 1) 8) 16)
	  (ash (canonicalize-n-unsigned (elt array 2) 8) 8)
	  (ash (canonicalize-n-unsigned (elt array 3) 8) 0)))

(defun ipaddr-to-array (ipaddr)
  (vector (canonicalize-n (ldb (byte 8 24) ipaddr) 8)
	  (canonicalize-n (ldb (byte 8 16) ipaddr) 8)
	  (canonicalize-n (ldb (byte 8 8) ipaddr) 8)
	  (canonicalize-n (ldb (byte 8 0) ipaddr) 8)))

(defconstant +plainsocketimpl-keep-alive+ 8)
(defconstant +plainsocketimpl-nodelay+ 1)

(defun fake-labeled-function (name lambda-expression)
  (funcall
   (compile nil `(lambda ()
		   (flet ((,name ,@(rest lambda-expression)))
		     #',name)))))
