;;;; Copyright (c) 2003,2004 David Lichteblau <david@lichteblau.com>
;;;;
;;;; This program is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2 of the License, or
;;;; (at your option) any later version.
;;;;
;;;; This program is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;;
;;;; You should have received a copy of the GNU General Public License
;;;; along with this program; if not, write to the Free Software
;;;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(defpackage :dlisp-system
  (:use :cl :asdf))
(in-package :dlisp-system)

(defclass silent-source-file (cl-source-file) ())

#+sbcl
(defmethod perform :around ((o compile-op) (s silent-source-file))
  (handler-bind ((sb-ext:compiler-note #'muffle-warning))
    (call-next-method)))

(defsystem :dlisp
  :default-component-class silent-source-file
  :depends-on (#+sbcl :sb-bsd-sockets)
  :components
  ((:file "package")
   (:file "common" :depends-on ("package" "misc"))
   (:file "impl"
	  :pathname #+sbcl "sbcl"
	            #+allegro "acl"
		    #+lispworks "lispworks"
		    #-(or sbcl allegro lispworks) ...
	  :depends-on ("common"))
   (:file "misc" :depends-on ("package"))
   (:file "word" :depends-on ("package"))))
