;;;; Copyright (c) 1999-2004 David Lichteblau <david@lichteblau.com>
;;;;
;;;; This program is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2 of the License, or
;;;; (at your option) any later version.
;;;;
;;;; This program is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;;
;;;; You should have received a copy of the GNU General Public License
;;;; along with this program; if not, write to the Free Software
;;;; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(in-package :cl-user)

(defpackage :dlisp
  (:use :cl)
  (:import-from #+sbcl :sb-ext
		#+allegro :excl
		#+lispworks :stream
		#-(or sbcl allegro lispworks) ...
		#:fundamental-binary-input-stream
		#:fundamental-binary-output-stream
		#:stream-write-byte
		#:stream-write-sequence
		#:stream-listen
		#:stream-read-byte)
  (:export #:with-gensyms		;Hilfsfunktionen aus misc.lisp
	   #:with-collector
	   #:collect
	   #:with-reducer
	   #:for-finish
	   #:%for
	   #:%for*
	   #:for
	   #:for*
	   #:while
	   #:until
	   #:do-sequence
	   #:listify
	   #:string-suffix-p
	   #:starts-with-p
	   #:n++
	   #:aif
	   #:%
	   #:mv-cond
	   #:make-bytes
	   #:adjust-vector-exponentially
	   #:vector-push-sequence
	   #:curry
	   #:rcurry
	   #:define-class
	   #:compose
	   
	   #:nanp			;Grausige Portabilitaetshacks
	   #:|java/lang/Double.doubleToRawLongBits(D)|
	   #:|java/lang/Double.longBitsToDouble(J)|
	   #:|java/lang/Float.floatToRawIntBits(F)|
	   #:|java/lang/Float.intBitsToFloat(I)|
	   #:read-sequence-partial-fill
	   #:get-host-by-address
	   #:get-host-by-name
	   #:make-socket
	   #:socket-stream
	   #:+socket-error+
	   #:set-socket-option
	   #:gc
	   #:string-to-utf-8
	   #:utf-8-to-string
	   #:decode-pseudo-utf-8
	   #:compile-labeled-function
	   #:disable-floating-point-traps
	   #:enable-floating-point-traps
	   #:directoryp
	   #:add-fd-handler
	   #:remove-fd-handler

	   ;; re-exportiertes Gray-Stream-Zeugs
	   #:fundamental-binary-input-stream
	   #:fundamental-binary-output-stream
	   #:stream-write-byte
	   #:stream-write-sequence
	   #:stream-listen
	   #:stream-read-byte))
